function [forMsgMean, forMsgVar, backMsgMean, backMsgVar, jmean] =  ...
EPLaplaceStep_back(mu1, invSigma1, prior1, mu2, invSigma2, prior2, A, visits, obs, numBird, ratio, option)

prior1 = prior1 * numBird;
prior1 = [prior1; numBird - sum(prior1)];
tempmu1 = [mu1; numBird - sum(mu1)];
%diff = tempmu1 - prior1;
if strcmp(option.SigmaType, 'prior')
    tempmu1 = prior1;
end

tempmu1(tempmu1 < 0.01) = 0.01;
tempmu1 = tempmu1 / sum(tempmu1) * numBird;
SigmaCond = diag(A(1 : end - 1, :) * tempmu1) - A(1 : end - 1, :) * diag(tempmu1) * A(1 : end - 1, :)';

d = A(1:end - 1, end);
transMat = A(1 : end - 1, 1 : end - 1) - d * ones(1, size(A, 2) - 1);


initx1 = obs + [mu1; numBird - sum(mu1)];
initx1(initx1 < 0 ) = 0.05;
initx1 = initx1 / sum(initx1) * numBird;
initx1 = initx1(1 : end - 1);

if ~isempty(mu1)
    opt = optimoptions(@fminunc, 'MaxIter', 400, 'TolX', 1e-4, 'GradObj','on', 'Hessian','off', 'DerivativeCheck', 'off', 'Display', 'off', 'Algorithm', 'quasi-newton');
  
    if strcmp(option.messageDirection, 'forward')
        [x1, ~, flag, out] = fminunc(@wrapfunc3, initx1, opt);        
    else
        [x1, ~, flag, out] = fminunc(@wrapfunc4, initx1, opt);    
    end
    
    tempH = ObsHess(ratio, x1, obs, visits, numBird);
    
%     tic
%     % optimization with L-BFGS-B
%     nv = length(initx1);
%     l  = ones(nv,1) * 0;     % no lower bound
%     u  = inf(nv,1);      % no upper bound
%     fun     = @(x)fminunc_wrapper(x, @(x) LaplaceObj2(x, mu4, invSigma4, ratio, visits, obs, numBird), ...
%                                      @(x) LaplaceGrad2(x, mu4, invSigma4, ratio, visits, obs, numBird)); 
%     opts    = struct('x0', initx1, 'm', 20, 'maxIts', 500, 'printEvery', 1e9, 'pgtol', 1e-7, 'factr', 1e5);
%     [x1, ~, info] = lbfgsb(fun, l, u, opts);
%     if info.iterations >= 500
%         display('Check optimization problem: too many iterations');
%     end
%     
%     time1 = toc;
%     tic
    % optimization with matlab function
%     opt = optimoptions(@fminunc, 'MaxIter', 1000, 'TolX', 1e-5, 'GradObj','on', 'Hessian','off', 'DerivativeCheck', 'off', 'Display', 'off', 'Algorithm', 'quasi-newton');
%     [x1, ~, flag, out] = fminunc(@wrapfunc2, initx1, opt);
%     if flag <= 0
%         display('Check the optimization problem~');
%     end
% 
%    options = struct();
%    options.Method = 'lbfgs';
%    options.Display = 'off';
%    [x1, f, exitmsg, output] = minFunc(@wrapfunc2, initx1, options); 
%      %x1 = Coodecent(initx1, mu4, invSigma4, ratio, visits, obs, numBird);
%      
%      tempH = ObsHess(ratio, x1, obs, visits, numBird);
%     time2 = toc;
%     %compare solutions of lbfgs and fminunc
%     if sum(abs(x1 - fminx1) > 1)
%         display('Solution not consistant');
%     end
      
      
%     u = (obs + 1) ./ (ratio .* visits);
%     s = u ./ (ratio .* visits);
%     invs = 1 ./ s;
%     invs(u <= 0) = 0;
%     s(u <= 0) = 0;
%     
%     invSigma5 = diag(invs(1 : end - 1)) + ones(length(mu1)) * invs(end);
%     Sigma5 = diag(s(1 : end - 1)) - s(1 : end - 1) * s(1 : end - 1)' / sum(s);
%     
%     mu5 = u(1 : end - 1) - s(1 : end - 1) * sum(u(1 : end - 1)) / sum(s);
%     if (invs(end) > 0)
%         mu5 = mu5 + s(1 : end - 1) * invs(end) * u(end) - s(1 : end - 1) * sum(s(1 : end - 1)) * invs(end) * u(end) / sum(s);
%     end
%     
%     x1 = (invSigma4 + invSigma5) \ (invSigma5 * mu5 + invSigma4 * mu4);
%     tempH = invSigma5;


else
    x1 = zeros(0, 1);
    tempH = zeros(size(invSigma1));
end

if strcmp(option.messageDirection, 'forward')
    x2 = transMat * x1 + numBird * d;
else
    x2 = (inv(SigmaCond) + invSigma2) \ (invSigma2 * mu2 + SigmaCond \ (transMat * x1 + numBird * d));
end

jmean = [x1; numBird - sum(x1); x2; numBird - sum(x2)];


backMsgMean = [];
backMsgVar = [];

if strcmp(option.messageDirection, 'forward')
    
    forMsgMean = x2;
    forMsgVar = inv(transMat / (invSigma1 + tempH) * transMat' + SigmaCond);
    forMsgVar = (forMsgVar + forMsgVar') / 2;
    
elseif strcmp(option.messageDirection, 'EP')
    backMsgVar = tempH + transMat' / (SigmaCond + inv(invSigma2)) * transMat;
    forMsgVar = inv(transMat / (invSigma1 + tempH) * transMat' + SigmaCond);
    forMsgVar = (forMsgVar + forMsgVar') / 2;
    backMsgVar = (backMsgVar + backMsgVar') / 2;
    
    backMsgMean =  x1 + backMsgVar \ (invSigma1 * (x1 - mu1));
    forMsgMean = x2 + forMsgVar \ (invSigma2 * (x2 - mu2)); 
else error('No such working method');
end

% wrapper function for fminunc
    function [obj, grad, H] = wrapfunc2(x)
        if any(x) < 0 || numBird - sum(x) < 0
            obj = 1e20;
        end
        obj = LaplaceObj2(x, mu4, invSigma4, ratio, visits, obs, numBird);
        if nargout > 1 % gradient required
            grad = LaplaceGrad2(x, mu4, invSigma4, ratio, visits, obs, numBird);
            if nargout > 2 % Hessian required
                H = diag(obs(1 : end - 1) ./ (x.^2)) + obs(end) ./ ((numBird - sum(x))^2);
                H = H + invSigma4;
            end
        end
    end

    
    % optimization function for forward message pass
    function [obj, grad] = wrapfunc3(x)
        if any(x) < 0 || numBird - sum(x) < 0
            obj = 1e20;
            grad = - ones(size(x));
            return;
        end
        
       	%obj = ObsLik(ratio, x1, obs, visits, numBird);
        %obj = obj + NormalLik(mu1, invSigma1, x1);
        obj = LaplaceObj2(x, mu1, invSigma1, ratio, visits, obs, numBird);
        if nargout > 1 % gradient required
            %grad = ObsGrad(ratio, x1, obs, visits, numBird);
            %grad = grad + NormalGrad(mu1, invSigma1, x1);
            grad = LaplaceGrad2(x, mu1, invSigma1, ratio, visits, obs, numBird);
        end
    end

    % optimization function for EP update
    function [obj, grad] = wrapfunc4(x1)
        if any(x1) < 0 || numBird - sum(x1) < 0
            obj = 1e20;
            grad = - ones(size(x1));
            return;
        end
        
        
       	obj = ObsLik(ratio, x1, obs, visits, numBird);
        obj = obj + NormalLik(mu1, invSigma1, x1);
        
        % Let x2 = (inv(SigmaCond) + invSigma2) \ (SigmaCond \ (transMat * x1 + nd) + invSigma2 * mu2) 
        % to maximize w.r.t. x2. Then apply this to the conditional
        % distribution get the function of the x1
        
        % let U = (inv(SigmaCond) + invSigma2) \ (SigmaCond \ transMat)
        % then U - transMat =  - (inv(SigmaCond) + invSigma2) \ invSigma2 * transMat 
        % 
        wx = - (inv(SigmaCond) + invSigma2) \ (invSigma2 * (transMat * x1));
        v = (inv(SigmaCond) + invSigma2) \ (invSigma2 * mu2 + SigmaCond \ (numBird * d));
        wu = v - numBird * d;
        obj = obj + 0.5 * (wx + wu)' * (SigmaCond \ (wx + wu));
        
        if nargout > 1 % gradient required
            grad = ObsGrad(ratio, x1, obs, visits, numBird);
            grad = grad + NormalGrad(mu1, invSigma1, x1);
            grad = grad + (- transMat' * (invSigma2 * ((inv(SigmaCond) + invSigma2) \ (SigmaCond \ (wx + wu))))) ;
        end
    end
end

